/*!
 * Axios Cache Interceptor 1.5.0
 * (c) 2021-present Arthur Fiorette & Contributors
 * Released under the MIT License.
 */
import{parse as e}from"cache-parser";import{deferred as t}from"fast-defer";import{hash as a}from"object-code";const r=Object.freeze({IfModifiedSince:"if-modified-since",LastModified:"last-modified",IfNoneMatch:"if-none-match",CacheControl:"cache-control",Pragma:"pragma",ETag:"etag",Expires:"expires",Age:"age",XAxiosCacheEtag:"x-axios-cache-etag",XAxiosCacheLastModified:"x-axios-cache-last-modified",XAxiosCacheStaleIfError:"x-axios-cache-stale-if-error"}),i=t=>{if(!t)return"not enough headers";const a=t[r.CacheControl];if(a){const{noCache:i,noStore:n,maxAge:o,maxStale:s,immutable:d,staleWhileRevalidate:c}=e(String(a));if(i||n)return"dont cache";if(d)return{cache:31536e6};if(void 0!==o){const e=t[r.Age];return{cache:e?1e3*(o-Number(e)):1e3*o,stale:void 0!==s?1e3*s:void 0!==c?1e3*c:void 0}}}const i=t[r.Expires];if(i){const e=Date.parse(String(i))-Date.now();return e>=0?{cache:e}:"dont cache"}return"not enough headers"};function n(){return n=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var a=arguments[t];for(var r in a)Object.prototype.hasOwnProperty.call(a,r)&&(e[r]=a[r])}return e},n.apply(this,arguments)}function o(e){return e?t=>e(t)||304===t:e=>e>=200&&e<300||304===e}function s(e="get",t=[]){return e=e.toLowerCase(),t.some(t=>t===e)}function d(e,t){t.headers||(t.headers={});const{etag:a,modifiedSince:i}=t.cache;if(a){var n;const i=!0===a?null==(n=e.data)?void 0:n.headers[r.ETag]:a;i&&(t.headers[r.IfNoneMatch]=i)}i&&(t.headers[r.IfModifiedSince]=!0===i?e.data.headers[r.LastModified]||new Date(e.createdAt).toUTCString():i.toUTCString())}function c(e,t){return 304===e.status&&t?(e.cached=!0,e.data=t.data,e.status=t.status,e.statusText=t.statusText,e.headers=n({},t.headers,e.headers),t):{data:e.data,status:e.status,statusText:e.statusText,headers:e.headers}}function u(e){const a=async i=>{if(i.id=e.generateKey(i),!1===i.cache)return e.debug({id:i.id,msg:"Ignoring cache because config.cache === false",data:i}),i;if(i.cache=n({},e.defaults.cache,i.cache),"object"==typeof i.cache.cachePredicate&&i.cache.cachePredicate.ignoreUrls&&i.url)for(const t of i.cache.cachePredicate.ignoreUrls)if(t instanceof RegExp?(t.lastIndex=0,t.test(i.url)):i.url.includes(t))return e.debug({id:i.id,msg:`Ignored because url (${i.url}) matches ignoreUrls (${i.cache.cachePredicate.ignoreUrls})`,data:{url:i.url,cachePredicate:i.cache.cachePredicate}}),i;var c,u,h,g,l,f;if(i.cache.cacheTakeover&&(null!=(c=i.headers)[u=r.CacheControl]||(c[u]="no-cache"),null!=(h=i.headers)[g=r.Pragma]||(h[g]="no-cache"),null!=(l=i.headers)[f=r.Expires]||(l[f]="0")),!s(i.method,i.cache.methods))return e.debug({id:i.id,msg:`Ignored because method (${i.method}) is not in cache.methods (${i.cache.methods})`}),i;let m=await e.storage.get(i.id,i);const p=i.cache.override;e:if("empty"===m.state||"stale"===m.state||p){if(e.waiting[i.id]&&!p&&(m=await e.storage.get(i.id,i),"empty"!==m.state)){e.debug({id:i.id,msg:"Waiting list had an deferred for this key, waiting for it to finish"});break e}return e.waiting[i.id]=t(),e.waiting[i.id].catch(()=>{}),await e.storage.set(i.id,{state:"loading",previous:p?m.data?"stale":"empty":m.state,data:m.data,createdAt:p&&!m.createdAt?Date.now():m.createdAt},i),"stale"===m.state&&(d(m,i),e.debug({id:i.id,msg:"Updated stale request"})),i.validateStatus=o(i.validateStatus),e.debug({id:i.id,msg:"Sending request, waiting for response",data:{overrideCache:p,state:m.state}}),("stale"===m.state||m.data)&&await(null==i.cache.hydrate?void 0:i.cache.hydrate(m)),i}let w;if("loading"===m.state){const t=e.waiting[i.id];if(!t)return m.data&&await(null==i.cache.hydrate?void 0:i.cache.hydrate(m)),i;e.debug({id:i.id,msg:"Detected concurrent request, waiting for it to finish"});try{w=await t}catch(t){return e.debug({id:i.id,msg:"Deferred rejected, requesting again",data:t}),m.data&&await(null==i.cache.hydrate?void 0:i.cache.hydrate(m)),a(i)}}else w=m.data;return i.transformResponse=void 0,i.adapter=function(){return Promise.resolve({config:i,data:w.data,headers:w.headers,status:w.status,statusText:w.statusText,cached:!0,id:i.id})},e.debug({id:i.id,msg:"Returning cached response"}),i};return{onFulfilled:a,apply:()=>e.interceptors.request.use(a)}}async function h(e,t){if("function"==typeof t)return t(e);const{statusCheck:a,responseMatch:r,containsHeaders:i}=t;if(a&&!await a(e.status)||r&&!await r(e))return!1;if(i)for(const[t,a]of Object.entries(i)){var n;if(!await a(null!=(n=e.headers[t.toLowerCase()])?n:e.headers[t]))return!1}return!0}async function g(e,t,a){if("function"==typeof a)return a(t);for(const[r,i]of Object.entries(a)){if("delete"===i){await e.remove(r,t.config);continue}const a=await e.get(r,t.config);if("loading"===a.state)continue;const n=await i(a,t);"delete"!==n?"ignore"!==n&&await e.set(r,n,t.config):await e.remove(r,t.config)}}function l(t){const a=async(e,a)=>{var r;await t.storage.remove(e,a),null==(r=t.waiting[e])||r.reject(),delete t.waiting[e]},i=async e=>{if(null==e||!e.config)throw t.debug({msg:"Response interceptor received an unknown response.",data:e}),e;e.id=e.config.id,null!=e.cached||(e.cached=!1);const i=e.config,n=i.cache;if(e.cached)return t.debug({id:e.id,msg:"Returned cached response"}),e;if(!n)return t.debug({id:e.id,msg:"Response with config.cache falsy",data:e}),e.cached=!1,e;if(n.update&&await g(t.storage,e,n.update),!s(i.method,n.methods))return t.debug({id:e.id,msg:`Ignored because method (${i.method}) is not in cache.methods (${n.methods})`,data:{config:i,cacheConfig:n}}),e;const o=await t.storage.get(e.id,i);if("loading"!==o.state)return t.debug({id:e.id,msg:"Response not cached and storage isn't loading",data:{cache:o,response:e}}),e;if(!o.data&&!await h(e,n.cachePredicate))return await a(e.id,i),t.debug({id:e.id,msg:"Cache predicate rejected this response"}),e;for(const t of Object.keys(e.headers))t.startsWith("x-axios-cache")&&delete e.headers[t];n.etag&&!0!==n.etag&&(e.headers[r.XAxiosCacheEtag]=n.etag),n.modifiedSince&&(e.headers[r.XAxiosCacheLastModified]=!0===n.modifiedSince?"use-cache-timestamp":n.modifiedSince.toUTCString());let d,u=n.ttl||-1;if(n.interpretHeader){const r=t.headerInterpreter(e.headers);if("dont cache"===r)return await a(e.id,i),t.debug({id:e.id,msg:"Cache header interpreted as 'dont cache'",data:{cache:o,response:e,expirationTime:r}}),e;"not enough headers"!==r&&("number"==typeof r?u=r:(u=r.cache,d=r.stale))}const l=c(e,o.data);"function"==typeof u&&(u=await u(e)),n.staleIfError&&(e.headers[r.XAxiosCacheStaleIfError]=String(u)),t.debug({id:e.id,msg:"Useful response configuration found",data:{cacheConfig:n,cacheResponse:l}});const f={state:"cached",ttl:u,staleTtl:d,createdAt:Date.now(),data:l},m=t.waiting[e.id];return m&&(m.resolve(f.data),delete t.waiting[e.id],t.debug({id:e.id,msg:"Found waiting deferred(s) and resolved them"})),await t.storage.set(e.id,f,i),t.debug({id:e.id,msg:"Response cached",data:{cache:f,response:e}}),e},n=async i=>{if(!i.isAxiosError||!i.config)throw t.debug({msg:"FATAL: Received an non axios error in the rejected response interceptor, ignoring.",data:i}),i;const n=i.config,o=n.id,d=n.cache,c=i.response;if(!d||!o)throw t.debug({msg:"Web request returned an error but cache handling is not enabled",data:{error:i}}),i;if(!s(n.method,d.methods))throw t.debug({id:o,msg:`Ignored because method (${n.method}) is not in cache.methods (${d.methods})`,data:{config:n,cacheConfig:d}}),await a(o,n),i;const u=await t.storage.get(o,n);if("loading"!==u.state||"stale"!==u.previous)throw t.debug({id:o,msg:"Caught an error in the request interceptor",data:{cache:u,error:i,config:n}}),await a(o,n),i;if(d.staleIfError){const a=String(null==c?void 0:c.headers[r.CacheControl]),s=a&&e(a).staleIfError,g="function"==typeof d.staleIfError?await d.staleIfError(c,u,i):!0===d.staleIfError&&s?1e3*s:d.staleIfError;var h;if(t.debug({id:o,msg:"Found cache if stale config for rejected response",data:{error:i,config:n,staleIfError:g}}),!0===g||"number"==typeof g&&u.createdAt+g>Date.now())return null==(h=t.waiting[o])||h.resolve(u.data),delete t.waiting[o],await t.storage.set(o,{state:"stale",createdAt:Date.now(),data:u.data},n),t.debug({id:o,msg:"staleIfError resolved this response with cached data",data:{error:i,config:n,cache:u}}),{cached:!0,config:n,id:o,data:u.data.data,headers:u.data.headers,status:u.data.status,statusText:u.data.statusText}}throw t.debug({id:o,msg:"Received an unknown error that could not be handled",data:{error:i,config:n}}),await a(o,n),i};return{onFulfilled:i,onRejected:n,apply:()=>t.interceptors.response.use(i,n)}}const f=e=>!!e&&!!e["is-storage"];function m(e){const t=e.data.headers;return r.ETag in t||r.LastModified in t||r.XAxiosCacheEtag in t||r.XAxiosCacheLastModified in t}function p(e){return!String(e.data.headers[r.CacheControl]).includes("must-revalidate")&&(!!m(e)||"cached"===e.state&&void 0!==e.staleTtl&&Math.abs(Date.now()-(e.createdAt+e.ttl))<=e.staleTtl)}function w(e){return void 0!==e.ttl&&e.createdAt+e.ttl<=Date.now()}function b({set:e,find:t,remove:a}){return{"is-storage":1,set:e,remove:a,get:async(r,i)=>{let n=await t(r,i);if(!n)return{state:"empty"};if("empty"===n.state||"loading"===n.state)return n;if("cached"===n.state){if(!w(n))return n;if(!p(n))return await a(r,i),{state:"empty"};n={state:"stale",createdAt:n.createdAt,data:n.data,ttl:void 0!==n.staleTtl?n.staleTtl+n.ttl:void 0},await e(r,n,i)}return w(n)?m(n)?n:(await a(r,i),{state:"empty"}):n}}}function v(e=!1,t=!1,a=!1){const r=b({set:(t,i)=>{if(a){let e=Object.keys(r.data);if(e.length>=a)for(r.cleanup(),e=Object.keys(r.data);e.length>=a;)delete r.data[e.shift()]}r.data[t]="double"===e?"function"==typeof structuredClone?structuredClone(i):JSON.parse(JSON.stringify(i)):i},remove:e=>{delete r.data[e]},find:t=>{const a=r.data[t];return e&&void 0!==a?"function"==typeof structuredClone?structuredClone(a):JSON.parse(JSON.stringify(a)):a}});return r.data=Object.create(null),r.cleanup=()=>{const e=Object.keys(r.data);let t,a,i=-1;for(;++i<e.length;)a=e[i],t=r.data[a],"empty"!==t.state?"cached"===t.state&&w(t)&&!p(t)&&r.remove(a):r.remove(a)},t&&(r.cleaner=setInterval(r.cleanup,t)),r}const y=/^\/|\/$/g;function C(e){return t=>{if(t.id)return t.id;const r=e(t);return"string"==typeof r||"number"==typeof r?`${r}`:`${a(r)}`}}const I=C(({baseURL:e,url:t,method:a,params:r,data:i})=>(e=void 0!==e?e.replace(y,""):"",t=void 0!==t?t.replace(y,""):"",{url:e+(e&&t?"/":"")+t,params:r,method:a=void 0!==a?a.toLowerCase():"get",data:i}));function x(e,t={}){var a,r,n,o,s,d,c,h;const g=e;if(g.defaults.cache)throw new Error("setupCache() should be called only once");if(g.storage=t.storage||v(),!f(g.storage))throw new Error("Use buildStorage() function");return g.waiting=t.waiting||{},g.generateKey=t.generateKey||I,g.headerInterpreter=t.headerInterpreter||i,g.requestInterceptor=t.requestInterceptor||u(g),g.responseInterceptor=t.responseInterceptor||l(g),g.debug=t.debug||function(){},g.defaults.cache={update:t.update||{},ttl:null!=(a=t.ttl)?a:3e5,methods:t.methods||["get","head"],cachePredicate:t.cachePredicate||{statusCheck:e=>[200,203,300,301,302,404,405,410,414,501].includes(e)},etag:null==(r=t.etag)||r,modifiedSince:null!=(n=t.modifiedSince)?n:!1===t.etag,interpretHeader:null==(o=t.interpretHeader)||o,cacheTakeover:null==(s=t.cacheTakeover)||s,staleIfError:null==(d=t.staleIfError)||d,override:null!=(c=t.override)&&c,hydrate:null!=(h=t.hydrate)?h:void 0},g.requestInterceptor.apply(),g.responseInterceptor.apply(),g}function S(e,t="axios-cache-"){return b({find:a=>{const r=e.getItem(t+a);return r?JSON.parse(r):void 0},remove:a=>{e.removeItem(t+a)},set:(a,r)=>{const i=()=>e.setItem(t+a,JSON.stringify(r));try{return i()}catch(r){const n=Object.entries(e).filter(e=>e[0].startsWith(t)).map(e=>[e[0],JSON.parse(e[1])]);for(const t of n)"cached"===t[1].state&&w(t[1])&&!p(t[1])&&e.removeItem(t[0]);try{return i()}catch(t){const a=n.sort((e,t)=>(e[1].createdAt||0)-(t[1].createdAt||0));for(const t of a){e.removeItem(t[0]);try{return i()}catch(e){}}}e.removeItem(t+a)}}})}console.error("You are using a development build. Make sure to use the correct build in production\nhttps://axios-cache-interceptor.js.org/guide/getting-started\n\n");export{r as Header,C as buildKeyGenerator,v as buildMemoryStorage,b as buildStorage,S as buildWebStorage,p as canStale,c as createCacheResponse,o as createValidateStatus,i as defaultHeaderInterpreter,I as defaultKeyGenerator,u as defaultRequestInterceptor,l as defaultResponseInterceptor,w as isExpired,s as isMethodIn,f as isStorage,x as setupCache,h as testCachePredicate,g as updateCache,d as updateStaleRequest};
//# sourceMappingURL=index.modern.js.map