/*!
 * Axios Cache Interceptor 1.5.0
 * (c) 2021-present Arthur Fiorette & Contributors
 * Released under the MIT License.
 */
import{parse as e}from"cache-parser";import{deferred as t}from"fast-defer";import{hash as a}from"object-code";const r=Object.freeze({IfModifiedSince:"if-modified-since",LastModified:"last-modified",IfNoneMatch:"if-none-match",CacheControl:"cache-control",Pragma:"pragma",ETag:"etag",Expires:"expires",Age:"age",XAxiosCacheEtag:"x-axios-cache-etag",XAxiosCacheLastModified:"x-axios-cache-last-modified",XAxiosCacheStaleIfError:"x-axios-cache-stale-if-error"}),n=t=>{if(!t)return"not enough headers";const a=t[r.CacheControl];if(a){const{noCache:n,noStore:o,maxAge:i,maxStale:s,immutable:c,staleWhileRevalidate:d}=e(String(a));if(n||o)return"dont cache";if(c)return{cache:31536e6};if(void 0!==i){const e=t[r.Age];return{cache:e?1e3*(i-Number(e)):1e3*i,stale:void 0!==s?1e3*s:void 0!==d?1e3*d:void 0}}}const n=t[r.Expires];if(n){const e=Date.parse(String(n))-Date.now();return e>=0?{cache:e}:"dont cache"}return"not enough headers"};function o(){return o=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var a=arguments[t];for(var r in a)Object.prototype.hasOwnProperty.call(a,r)&&(e[r]=a[r])}return e},o.apply(this,arguments)}function i(e){return e?t=>e(t)||304===t:e=>e>=200&&e<300||304===e}function s(e="get",t=[]){return e=e.toLowerCase(),t.some(t=>t===e)}function c(e,t){t.headers||(t.headers={});const{etag:a,modifiedSince:n}=t.cache;if(a){var o;const n=!0===a?null==(o=e.data)?void 0:o.headers[r.ETag]:a;n&&(t.headers[r.IfNoneMatch]=n)}n&&(t.headers[r.IfModifiedSince]=!0===n?e.data.headers[r.LastModified]||new Date(e.createdAt).toUTCString():n.toUTCString())}function d(e,t){return 304===e.status&&t?(e.cached=!0,e.data=t.data,e.status=t.status,e.statusText=t.statusText,e.headers=o({},t.headers,e.headers),t):{data:e.data,status:e.status,statusText:e.statusText,headers:e.headers}}function u(e){const a=async n=>{if(n.id=e.generateKey(n),!1===n.cache)return n;if(n.cache=o({},e.defaults.cache,n.cache),"object"==typeof n.cache.cachePredicate&&n.cache.cachePredicate.ignoreUrls&&n.url)for(const e of n.cache.cachePredicate.ignoreUrls)if(e instanceof RegExp?(e.lastIndex=0,e.test(n.url)):n.url.includes(e))return n;var d,u,l,f,h,g;if(n.cache.cacheTakeover&&(null!=(d=n.headers)[u=r.CacheControl]||(d[u]="no-cache"),null!=(l=n.headers)[f=r.Pragma]||(l[f]="no-cache"),null!=(h=n.headers)[g=r.Expires]||(h[g]="0")),!s(n.method,n.cache.methods))return n;let p=await e.storage.get(n.id,n);const m=n.cache.override;e:if("empty"===p.state||"stale"===p.state||m){if(e.waiting[n.id]&&!m&&(p=await e.storage.get(n.id,n),"empty"!==p.state))break e;return e.waiting[n.id]=t(),e.waiting[n.id].catch(()=>{}),await e.storage.set(n.id,{state:"loading",previous:m?p.data?"stale":"empty":p.state,data:p.data,createdAt:m&&!p.createdAt?Date.now():p.createdAt},n),"stale"===p.state&&c(p,n),n.validateStatus=i(n.validateStatus),("stale"===p.state||p.data)&&await(null==n.cache.hydrate?void 0:n.cache.hydrate(p)),n}let w;if("loading"===p.state){const t=e.waiting[n.id];if(!t)return p.data&&await(null==n.cache.hydrate?void 0:n.cache.hydrate(p)),n;try{w=await t}catch(e){return p.data&&await(null==n.cache.hydrate?void 0:n.cache.hydrate(p)),a(n)}}else w=p.data;return n.transformResponse=void 0,n.adapter=function(){return Promise.resolve({config:n,data:w.data,headers:w.headers,status:w.status,statusText:w.statusText,cached:!0,id:n.id})},n};return{onFulfilled:a,apply:()=>e.interceptors.request.use(a)}}async function l(e,t){if("function"==typeof t)return t(e);const{statusCheck:a,responseMatch:r,containsHeaders:n}=t;if(a&&!await a(e.status)||r&&!await r(e))return!1;if(n)for(const[t,a]of Object.entries(n)){var o;if(!await a(null!=(o=e.headers[t.toLowerCase()])?o:e.headers[t]))return!1}return!0}async function f(e,t,a){if("function"==typeof a)return a(t);for(const[r,n]of Object.entries(a)){if("delete"===n){await e.remove(r,t.config);continue}const a=await e.get(r,t.config);if("loading"===a.state)continue;const o=await n(a,t);"delete"!==o?"ignore"!==o&&await e.set(r,o,t.config):await e.remove(r,t.config)}}function h(t){const a=async(e,a)=>{var r;await t.storage.remove(e,a),null==(r=t.waiting[e])||r.reject(),delete t.waiting[e]},n=async e=>{if(null==e||!e.config)throw e;e.id=e.config.id,null!=e.cached||(e.cached=!1);const n=e.config,o=n.cache;if(e.cached)return e;if(!o)return e.cached=!1,e;if(o.update&&await f(t.storage,e,o.update),!s(n.method,o.methods))return e;const i=await t.storage.get(e.id,n);if("loading"!==i.state)return e;if(!i.data&&!await l(e,o.cachePredicate))return await a(e.id,n),e;for(const t of Object.keys(e.headers))t.startsWith("x-axios-cache")&&delete e.headers[t];o.etag&&!0!==o.etag&&(e.headers[r.XAxiosCacheEtag]=o.etag),o.modifiedSince&&(e.headers[r.XAxiosCacheLastModified]=!0===o.modifiedSince?"use-cache-timestamp":o.modifiedSince.toUTCString());let c,u=o.ttl||-1;if(o.interpretHeader){const r=t.headerInterpreter(e.headers);if("dont cache"===r)return await a(e.id,n),e;"not enough headers"!==r&&("number"==typeof r?u=r:(u=r.cache,c=r.stale))}const h=d(e,i.data);"function"==typeof u&&(u=await u(e)),o.staleIfError&&(e.headers[r.XAxiosCacheStaleIfError]=String(u));const g={state:"cached",ttl:u,staleTtl:c,createdAt:Date.now(),data:h},p=t.waiting[e.id];return p&&(p.resolve(g.data),delete t.waiting[e.id]),await t.storage.set(e.id,g,n),e},o=async n=>{if(!n.isAxiosError||!n.config)throw n;const o=n.config,i=o.id,c=o.cache,d=n.response;if(!c||!i)throw n;if(!s(o.method,c.methods))throw await a(i,o),n;const u=await t.storage.get(i,o);if("loading"!==u.state||"stale"!==u.previous)throw await a(i,o),n;if(c.staleIfError){const a=String(null==d?void 0:d.headers[r.CacheControl]),s=a&&e(a).staleIfError,f="function"==typeof c.staleIfError?await c.staleIfError(d,u,n):!0===c.staleIfError&&s?1e3*s:c.staleIfError;var l;if(!0===f||"number"==typeof f&&u.createdAt+f>Date.now())return null==(l=t.waiting[i])||l.resolve(u.data),delete t.waiting[i],await t.storage.set(i,{state:"stale",createdAt:Date.now(),data:u.data},o),{cached:!0,config:o,id:i,data:u.data.data,headers:u.data.headers,status:u.data.status,statusText:u.data.statusText}}throw await a(i,o),n};return{onFulfilled:n,onRejected:o,apply:()=>t.interceptors.response.use(n,o)}}const g=e=>!!e&&!!e["is-storage"];function p(e){const t=e.data.headers;return r.ETag in t||r.LastModified in t||r.XAxiosCacheEtag in t||r.XAxiosCacheLastModified in t}function m(e){return!String(e.data.headers[r.CacheControl]).includes("must-revalidate")&&(!!p(e)||"cached"===e.state&&void 0!==e.staleTtl&&Math.abs(Date.now()-(e.createdAt+e.ttl))<=e.staleTtl)}function w(e){return void 0!==e.ttl&&e.createdAt+e.ttl<=Date.now()}function v({set:e,find:t,remove:a}){return{"is-storage":1,set:e,remove:a,get:async(r,n)=>{let o=await t(r,n);if(!o)return{state:"empty"};if("empty"===o.state||"loading"===o.state)return o;if("cached"===o.state){if(!w(o))return o;if(!m(o))return await a(r,n),{state:"empty"};o={state:"stale",createdAt:o.createdAt,data:o.data,ttl:void 0!==o.staleTtl?o.staleTtl+o.ttl:void 0},await e(r,o,n)}return w(o)?p(o)?o:(await a(r,n),{state:"empty"}):o}}}function y(e=!1,t=!1,a=!1){const r=v({set:(t,n)=>{if(a){let e=Object.keys(r.data);if(e.length>=a)for(r.cleanup(),e=Object.keys(r.data);e.length>=a;)delete r.data[e.shift()]}r.data[t]="double"===e?"function"==typeof structuredClone?structuredClone(n):JSON.parse(JSON.stringify(n)):n},remove:e=>{delete r.data[e]},find:t=>{const a=r.data[t];return e&&void 0!==a?"function"==typeof structuredClone?structuredClone(a):JSON.parse(JSON.stringify(a)):a}});return r.data=Object.create(null),r.cleanup=()=>{const e=Object.keys(r.data);let t,a,n=-1;for(;++n<e.length;)a=e[n],t=r.data[a],"empty"!==t.state?"cached"===t.state&&w(t)&&!m(t)&&r.remove(a):r.remove(a)},t&&(r.cleaner=setInterval(r.cleanup,t)),r}const x=/^\/|\/$/g;function C(e){return t=>{if(t.id)return t.id;const r=e(t);return"string"==typeof r||"number"==typeof r?`${r}`:`${a(r)}`}}const I=C(({baseURL:e,url:t,method:a,params:r,data:n})=>(e=void 0!==e?e.replace(x,""):"",t=void 0!==t?t.replace(x,""):"",{url:e+(e&&t?"/":"")+t,params:r,method:a=void 0!==a?a.toLowerCase():"get",data:n}));function S(e,t={}){var a,r,o,i,s,c,d,l;const f=e;if(f.defaults.cache)throw new Error("setupCache() should be called only once");if(f.storage=t.storage||y(),!g(f.storage))throw new Error("Use buildStorage() function");return f.waiting=t.waiting||{},f.generateKey=t.generateKey||I,f.headerInterpreter=t.headerInterpreter||n,f.requestInterceptor=t.requestInterceptor||u(f),f.responseInterceptor=t.responseInterceptor||h(f),f.debug=t.debug||function(){},f.defaults.cache={update:t.update||{},ttl:null!=(a=t.ttl)?a:3e5,methods:t.methods||["get","head"],cachePredicate:t.cachePredicate||{statusCheck:e=>[200,203,300,301,302,404,405,410,414,501].includes(e)},etag:null==(r=t.etag)||r,modifiedSince:null!=(o=t.modifiedSince)?o:!1===t.etag,interpretHeader:null==(i=t.interpretHeader)||i,cacheTakeover:null==(s=t.cacheTakeover)||s,staleIfError:null==(c=t.staleIfError)||c,override:null!=(d=t.override)&&d,hydrate:null!=(l=t.hydrate)?l:void 0},f.requestInterceptor.apply(),f.responseInterceptor.apply(),f}function b(e,t="axios-cache-"){return v({find:a=>{const r=e.getItem(t+a);return r?JSON.parse(r):void 0},remove:a=>{e.removeItem(t+a)},set:(a,r)=>{const n=()=>e.setItem(t+a,JSON.stringify(r));try{return n()}catch(r){const o=Object.entries(e).filter(e=>e[0].startsWith(t)).map(e=>[e[0],JSON.parse(e[1])]);for(const t of o)"cached"===t[1].state&&w(t[1])&&!m(t[1])&&e.removeItem(t[0]);try{return n()}catch(t){const a=o.sort((e,t)=>(e[1].createdAt||0)-(t[1].createdAt||0));for(const t of a){e.removeItem(t[0]);try{return n()}catch(e){}}}e.removeItem(t+a)}}})}export{r as Header,C as buildKeyGenerator,y as buildMemoryStorage,v as buildStorage,b as buildWebStorage,m as canStale,d as createCacheResponse,i as createValidateStatus,n as defaultHeaderInterpreter,I as defaultKeyGenerator,u as defaultRequestInterceptor,h as defaultResponseInterceptor,w as isExpired,s as isMethodIn,g as isStorage,S as setupCache,l as testCachePredicate,f as updateCache,c as updateStaleRequest};
//# sourceMappingURL=index.modern.js.map